import {ItemGroup} from "./ItemGroup";
import {Item} from "./Item";

export class ConcreteItemGroup extends ItemGroup {

  items: Item[] = [];

  addItem(item: Item) {
    if(this.findItemByName(item.componentName) == undefined) {
      item.addInheritedGroup(this);
      this.items.push(item);
    }
  }

  findItemByName(itemName: string) {
    return this.items.find(item => item.componentName === itemName);
  }
}
